function lasso_demo()
%UNTITLED7 Summary of this function goes here
%   Detailed explanation goes here

    % Nacteme Hitters
    % Prvni sloupec v .csv jsou jmena hracu, proto 'ReadRowNames'
    % U platu obcas neni uveden plat, je tam 'NA'. Tyto hodnoty je treba
    % prevest na NaN, proto 'TreatAsEmpty' 
    hitters = readtable('islr_hitters.csv','ReadRowNames',true,'TreatAsEmpty','NA');
    % Rozmer tabulky
    size(hitters)
    % Kolik tam mame hracu bez uvedeneho platu
    sum(isnan(hitters.Salary))
    % Odstranime je
    missing = ismissing(hitters);
    hitters2 = hitters(~any(missing,2),:);    
    % Rozmer nove tabulky
    size(hitters2)
    % Kolik tam mame hracu bez uvedeneho platu
    sum(isnan(hitters2.Salary))
    
    % Potrebujeme vse ciselne, takze League, NewLeague a Division musime
    % konvertovat na cisla
    hitters2.League = double(categorical(hitters2.League))-1;
    hitters2.Division = double(categorical(hitters2.Division))-1;
    hitters2.NewLeague = double(categorical(hitters2.NewLeague))-1;
    % Hrebenova regrese potrebuje vektor vystupu a matici vstupu
    X = table2array(hitters2);
    X(:,end-1) = [];  % Smazat platy
    y = hitters2.Salary;
    
    % Rozdlen na trnovac a testovac sadu
    rng(2);
    idx = randsample(length(y), floor(length(y)/2));  % Nahodne 50%
    train_idx = 1:length(y);
    train_idx = sort(train_idx(idx));  % Data v idx jsou nahodne za sebou
    test_idx = 1:length(y);
    test_idx(idx) = [];  % Testovaci data nejsou ta trenovaci

    X_train = X(train_idx,:);
    X_test = X(test_idx,:);
    y_train = y(train_idx);
    y_test = y(test_idx);
    
    % ISLR pouziva lambda od 10^10 do 10^-2 a je jich 100
    lambda = 10.^linspace(10,-2,100);
    [lso.coefs, lso.fi] = lasso(X_train,y_train,'Lambda',lambda);
    % Implicitni sada lambda generovana fuinkci lasso()
    % [lso.coefs, lso.fi] = lasso(X_train,y_train);
    % Vykreslit koeficienty jako funkce lambda
    figure(20);
    semilogx(lso.fi.Lambda,lso.coefs);
    xlabel('lambda');
    ylabel('coefficient value');
    % Tohle to vykresli podobne
    lassoPlot(lso.coefs,lso.fi);
    % Absolutni clen to vraci v lso.fi.Intercept
    % Padesata lambda a koeficienty
    lso.fi.Lambda(50)
    lso.coefs(:,50)
    sqrt(sum(lso.coefs(:,50).^2))
    % Sedesata lambda a koeficienty
    lso.fi.Lambda(60)
    lso.coefs(:,60)
    sqrt(sum(lso.coefs(:,60).^2))
    % Sedesata lambda a koeficienty
    lso.fi.Lambda(80)
    lso.coefs(:,80)
    sqrt(sum(lso.coefs(:,80).^2))
    
    % Tady by slo jeste hledat lambda s minimalnim MSE
    % mean((y_pred-y_test).^2)
    
    % To same s 5nasobnou krizovou validaci
    [lsocv.coefs, lsocv.fi] = lasso(X,y,'CV',5,'Lambda',lambda);
    % Chyba predikce na testovacich datech:
    % Vykreslime MSE u krizove validace
    lassoPlot(lsocv.coefs, lsocv.fi,'PlotType','CV');
    % TODO: Nebo bychom mohli vykreslit tohle
    figure(22);
    semilogx(lsocv.fi.Lambda, lsocv.fi.MSE);
    xlabel('lambda');
    ylabel('MSE on test data');
    % Vyber nejlepsi lambdy a ukazka chyby predikce a koeficientu
    lsocv.fi.IndexMinMSE  % Index lambdy s minimalnim CV MSE
    lsocv.fi.LambdaMinMSE  % Hodnota te lambdy
    lsocv.fi.MSE(lsocv.fi.IndexMinMSE)  % MSE
    lsocv.coefs(lsocv.fi.IndexMinMSE)  % Koeficienty
end

