function ridge_demo()
%UNTITLED6 Summary of this function goes here
%   Detailed explanation goes here

    % Do budoucna mozna pouzijeme glmnet
    % http://web.stanford.edu/~hastie/glmnet_matlab/download.html
    
    % Nacteme Hitters
    % Prvni sloupec v .csv jsou jmena hracu, proto 'ReadRowNames'
    % U platu obcas neni uveden plat, je tam 'NA'. Tyto hodnoty je treba
    % prevest na NaN, proto 'TreatAsEmpty' 
    hitters = readtable('islr_hitters.csv','ReadRowNames',true,'TreatAsEmpty','NA');
    % Rozmer tabulky
    size(hitters)
    % Kolik tam mame hracu bez uvedeneho platu
    sum(isnan(hitters.Salary))
    % Odstranime je
    missing = ismissing(hitters);
    hitters2 = hitters(~any(missing,2),:);    
    % Rozmer nove tabulky
    size(hitters2)
    % Kolik tam mame hracu bez uvedeneho platu
    sum(isnan(hitters2.Salary))
    
    % Potrebujeme vse ciselne, takze League, NewLeague a Division musime
    % konvertovat na cisla
    hitters2.League = double(categorical(hitters2.League))-1;
    hitters2.Division = double(categorical(hitters2.Division))-1;
    hitters2.NewLeague = double(categorical(hitters2.NewLeague))-1;
    % Hrebenova regrese potrebuje vektor vystupu a matici vstupu
    X = table2array(hitters2);
    X(:,end-1) = [];  % Smazat platy
    y = hitters2.Salary;
    
    % ISLR pouziva lambda od 10^10 do 10^-2 a je jich 100
    rr.lambda = 10.^linspace(10,-2,100);
    rr.coefs = ridge(y,X,rr.lambda,0);  % Chceme absolutni clen
    % Padesata lambda a koeficienty
    rr.lambda(50)
    rr.coefs(:,50)
    sqrt(sum(rr.coefs(:,50).^2))
    % Sedesata lambda a koeficienty
    rr.lambda(60)
    rr.coefs(:,60)
    sqrt(sum(rr.coefs(:,60).^2))
    % Sedesata lambda a koeficienty
    rr.lambda(80)
    rr.coefs(:,80)
    sqrt(sum(rr.coefs(:,80).^2))
    
    % PREDICT z ISLR v Matlabu nemme
    
    % Rozdlen na trnovac a testovac sadu
    rng(2);
    idx = randsample(length(y), floor(length(y)/2));  % Nahodne 50%
    train_idx = 1:length(y);
    train_idx = sort(train_idx(idx));  % Data v idx jsou nahodne za sebou
    test_idx = 1:length(y);
    test_idx(idx) = [];  % Testovaci data nejsou ta trenovaci
    
    tcoefs = ridge(y(train_idx),X(train_idx,:),[10^10, 4, 0.001],0);
    % Predikce modelu pro lambda
    % Prvni koeficient je absolutni clen, ten nenasobime Xem
    % Transpozice jsou dusledkem toho, ze potrbujeme vystup jako sloupcovy
    % vektor
    y_pred_1 = tcoefs(1,1) + (tcoefs(2:end,1)'*X(test_idx,:)')';
    y_pred_2 = tcoefs(1,2) + (tcoefs(2:end,2)'*X(test_idx,:)')';
    y_pred_3 = tcoefs(1,3) + (tcoefs(2:end,3)'*X(test_idx,:)')';    
    % MSE tech predikci
    y_test = y(test_idx);
    mean((y_pred_1-y_test).^2)
    mean((y_pred_2-y_test).^2)
    mean((y_pred_3-y_test).^2)
    
    % TODO: Tady by se daly jeste udelat krizove validace, pokud bychom
    % tedy pouzili glmnet, protoze Matlab je zabudovane nema.
end

